#define TuTTy "Cosmin-Mihai Tutunaru"
#include <cstdio>
#define infile "mostenire.in"
#define outfile "mostenire.out"
#define nMax 131
#define mMax 1013

using namespace std;

int cnt[nMax][mMax];
char forest[nMax][mMax];
int n, m;
int sol;

void read() {
    scanf("%d %d\n", &n, &m);
    for (int i = 1; i < n+1; ++i) {
        fgets(forest[i] + 1, mMax, stdin);
    }
}

int getSum(int i1, int j1, int i2, int j2) {
    return cnt[i2][j2] - cnt[i2][j1-1] - cnt[i1-1][j2] + cnt[i1-1][j1-1];
}

bool valid(int i1, int j1, int i2, int j2) {
    int w = j2 - j1 + 1;
    int h = i2 - i1 + 1;

    if (getSum(i1, j1, i2, j1) != h) {
        return false;
    }

    if (getSum(i1, j2, i2, j2) != h) {
        return false;
    }

    if (getSum(i1, j1, i1, j2) != w) {
        return false;
    }

    if (getSum(i2, j1, i2, j2) != w) {
        return false;
    }

    if (getSum(i1+1, j1+1, i2-1, j2-1) == (w-2) * (h-2)) {
        return false;
    }

    return true;
}

void solve() {
    for (int i = 1; i < n+1; ++i) {
        for (int j = 1; j < m+1; ++j) {
            cnt[i][j] = cnt[i-1][j] + cnt[i][j-1] - cnt[i-1][j-1] +
                (forest[i][j] - '0');
        }
    }

    for (int i1 = 1; i1 < n+1; ++i1) {
        for (int j1 = 1; j1 < m+1; ++j1) {
            for (int i2 = i1+2; i2 < n+1; ++i2) {
                for (int j2 = j1+2; j2 < m+1; ++j2) {
                    sol += valid(i1, j1, i2, j2);
                }
            }
        }
    }
}

void write() {
    printf("%d\n", sol);
}

int main() {
    freopen(infile, "r", stdin);
    freopen(outfile, "w", stdout);

    read();
    solve();
    write();

    fclose(stdin);
    fclose(stdout);
    return 0;
}
